//
//  htmlParserViewController.m
//  htmlParser
//
//  Created by kunii on 10/05/30.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "htmlParserViewController.h"

@implementation htmlParserViewController



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
	サーバから送られてくる素のHTMLテキストをコンソールに表示した上でwebviewにも表示する。
*/
- (void)connection:(NSURLConnection*)connection
        didReceiveData:(NSData*)data
{
	char* p = (char*)[data bytes];
	int len = [data length];
	while (len-- > 0) {
		putchar(*p++);
	}
	//	webviewへの表示
	NSString* htmlstring = [[NSString alloc] initWithData:data 
		encoding:NSUTF8StringEncoding];
	[webview loadHTMLString:htmlstring
		baseURL:[NSURL URLWithString:@"http://localhost/konohana/mainlist.php"]];
	[htmlstring release];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	//	HTML文をコンソール上に出力させるために残している。
	NSURLRequest* request = [NSURLRequest requestWithURL:
		[NSURL URLWithString:@"http://localhost/konohana/mainlist.php"]];
	// URLコネクションを作る
	[NSURLConnection connectionWithRequest:request delegate:self];

	//	URLを指定して直接解析する。
	NSXMLParser* parser = [[NSXMLParser alloc] initWithContentsOfURL:[NSURL URLWithString:@"http://localhost/konohana/mainlist.php"]];
	parser.delegate = self;
	[parser parse];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark NSXMLParser delegate methods

/*
	新しいタグが開いた
*/	
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {
//	printf("%s\n", [elementName UTF8String]);
//	NSLog(@"%@", attributeDict);	
	NSString* className = [attributeDict valueForKey:@"class"];
	if ([className isEqualToString:@"thumb"]) {
		thumbFlag = YES;
	}
	if ([className isEqualToString:@"contents"]) {
		printf("ID = %s\n", [[attributeDict valueForKey:@"href"] UTF8String]);
	}
	if (thumbFlag && [elementName isEqualToString:@"img"]) {
		printf("image URL = %s\n", [[attributeDict valueForKey:@"src"] UTF8String]);
		thumbFlag = NO;
	}
	//	<タグ>と</タグ>の間にある文字列はここでリセットする。
	[currentParsedCharacterData release];
	currentParsedCharacterData = nil;
}

/*
	タグが閉じた
*/	
- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {     
}

/*
	<タグ>と</タグ>の間にある文字列
*/
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
    if (!currentParsedCharacterData) {
		currentParsedCharacterData = [[NSMutableString alloc]init];
    }
	[currentParsedCharacterData appendString:string];
}

/*
	エラー発生
*/
- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError {
}
@end


